#include "asm86.h"
#include "ti86ops.inc"
#include "ti86asm.inc"
#include "ti86math.inc"
#include "ti86un.inc"
_ioprompt	.equ	0C324h
_mov10b		.equ	$427b
.org 0D748h
	call _runindicoff
TOP:
	call _clrLCD
	ld hl,Title1
	call _homeup
	call _puts
	ld hl,Title2
	call _puts
	ld hl,Title3
	call _puts
	call press_enter
	call _clrLCD
	call _homeup
	call Menu_txt
loop:
	call _ONEkey
	cp Pvoid
	jp z,loop
	cp Pon
	jr z,loop
	cp P1
	jr z,Xint
	cp P2
	jp z,Yint
	cp P3
	jp z,TEACHER
	cp P4
	jp z,end
	jp loop
Xint:
	call clear
	ld hl,Str1
	call _homeup
	call _puts
	ld hl,Strx
	ld bc,$0101
	call PrepPrmpt			;prompt X
	call _OP1TOOP4			;move result to op4
	ld hl,Stry
	ld bc,$0102
	call PrepPrmpt			;prompt Y
	call _OP1TOOP5			;move result to op5
	ld hl,Stre
	ld bc,$0103
	call PrepPrmpt			;prompt answer
	call _OP1TOOP6			;move result to op6
	call XMath			;calculate X-int
	ld hl,Xnt
	call ResultX       		;display the X-int
	call press_enter
	jp Return
Yint:
	call clear
	ld hl,Str2
	call _homeup
	call _puts
	ld hl,Strx
	ld bc,$0101
	call PrepPrmpt			;prompt X
	call _OP1TOOP4			;move result to op4
	ld hl,Stry
	ld bc,$0102
	call PrepPrmpt			;prompt Y
	call _OP1TOOP5			;move result to op5
	ld hl,Stre
	ld bc,$0103
	call PrepPrmpt			;prompt answer
	call _OP1TOOP6			;move result to op6
	jp promptOP			;+ or - ???
ymadd:
	call YMatha			;calculate Y-int
	jr next
ymsub:
	call YMaths
next:
	ld hl,Ynt
	call ResultY			;display the Y-int
	call press_enter
	jp Return
;*****
;calls
;*****
TEACHER:
	call TEACHEROFF
	jp Return
TEACHEROFF:
	push af
	ld a,1
	out (3),a
	call _pause
	ld a,11
	out (3),a
	pop af
	ret
XMath:
	call _OP6TOOP1
	call _OP5TOOP2
	call _FPDIV
	ret
YMatha:
	call _OP6TOOP1
	call _OP4TOOP2
	call _FPDIV
	call _OP1TOOP6
	call _OP5TOOP1
	call _OP4TOOP2
	call _FPDIV
	call _OP1TOOP2
	call _OP6TOOP1
	call _FPADD
	ret
YMaths:
	call _OP6TOOP1
	call _OP4TOOP2
	call _FPDIV
	call _OP1TOOP6
	call _OP5TOOP1
	call _OP4TOOP2
	call _FPDIV
	call _OP1TOOP2
	call _OP6TOOP1
	call _FPSUB
	ret
clear:
	call _clrLCD
	call _clrWindow
	call _homeup
	ret
ResultX:
	call clear
	call _dispOP1
	call _homeup
	ld hl,xxx
	call _puts
	ld a,(_curRow)
	inc a
	inc a
	ld (_curRow),a
	ld a,5
	ld (_curCol),a
	ld hl,Xnt
	call _puts
	call press_enter
	call _clrLCD
	ret
ResultY:
	call clear
	call _dispOP1
	call _homeup
	ld hl,yyy
	call _puts
	ld hl,yy
	call incR
	ld a,0
	ld (_curCol),a
	call _puts
	ld a,(_curRow)
	inc a
	inc a
	ld (_curRow),a
	ld a,5
	ld (_curCol),a
	ld hl,Ynt
	call _puts
	call press_enter
	call clear
	ret
incR:
	push af
	ld a,(_curRow)
	inc a
	ld (_curRow),a
	pop af
	ret
Menu_txt:
	ld hl,Menu1
	call onec
	call _puts
	ld hl,Menu2
	call incR
	call onec
	call _puts
	ld hl,Menu3
	call incR
	call onec
	call _puts
	ld hl,Menu4
	call onec
	call incR
	call _puts
	ret
onec:
	push af
	ld a,1
	ld (_curCol),a
	pop af
	ret
Prompt_op1:
	ld (_curRow),bc
	ld de,_ioprompt
	call Prompt			;prompt and move to op1
	ret
Prompt:
	call _mov10b			;move to prompt buffer, 10 bytes
	ld a,0Dh
	ld (_asap_ind),a
	call _exec_pg3
	ret
PrepPrmpt:
	ld de,_ioprompt
	call Prompt_op1	                ;prompt and move to op1
	ret
promptOP:
	call clear
	ld hl,op1
	call _homeup
	call _puts
	ld hl,op2
	call _puts
loop1:
	call _ONEkey
	cp Pvoid
	jr z,loop1
	cp Pon
	jr z,loop1
	cp Padd
	jp z,ymadd
	cp Psub
	jp z,ymsub
	jp loop1
press_enter:
	push af
	ld hl,enter
	ld a,6
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	sub a
	pop af
	call _puts
	call _getkey
	ret
Return:
	call clear
	jp TOP
end:
	call clear
	ld hl,quit1
	call _puts
	ld hl,quit2
	call _puts
	call press_enter
	call clear
	call _runindicon
	ret
Title1: .db " Intercepts of lines ",0
Title2: .db " V 1.0 for the 86-85 ",0
Title3: .db "   By Levi Jackson   ",0
Menu1: .db "1) Find X-int",0
Menu2: .db "2) Find Y-int",0
Menu4: .db "4) Quit Prgm",0
Menu3: .db "3) Teacher Key",0
quit1: .db " www.spectorNCC1701E ",0
quit2: .db "      @aol .com      ",0
quit3: .db "    <press enter>    ",0
Str1: 	.db " Find X-int of Line: ",0
Str2: 	.db " Find Y-int of Line: ",0
Strx: 	.db "X",0
Stry: 	.db "Y",0
Stre: 	.db "=",0
enter:  .db "    <press enter>    ",0
op1: .db " (+)",0
op2: .db " (-)",0
Xnt:	.db "X-int form.",0
Ynt:	.db "Y-int form.",0
yy:     .db "x",0
yyy: .db "y=",0
xxx: .db "x=",0
.end
END